/*! \mainpage Task Description
 *
 * Implement the functions below.
 *
 * Unless stated otherwise, all the functions are expected to return nothing.
 *
 * @file
 */

#include "solution.hpp"

/**
 * Creates a dynamically allocated array of integers and returns a pointer to it.
 *
 * The arguments begin and end specify an inclusive range [begin,end] of values. Hence, begin <= end at all times.
 * In example, createIntegerArray(5,10) will allocate memory for 6 integers, write values 5,6,7,8,9,10 into the allocated memory and return a pointer
 * to it.
 *
 * In case an invalid argument is supplied, the function must throw an instance of std::runtime_error.
 *
 * @param begin an integer specifying the minimal element in the inclusive range of values to be stored in allocated array. It must not exceed the value of end at all times.
 * @param end an integer specifying the maximal element in the inclusive range of values to be stored in allocated array. It must never be less than begin.
 * @return a pointer to dynamically allocated memory.
 */
int* my::createIntegerArray(int begin, int end) {
    return nullptr;
}

/**
 * Creates a dynamically allocated array of characters and returns a pointer to it.
 *
 * The arguments begin and end specify an inclusive range [begin,end] of values. Hence, begin <= end at all times.
 * In example, createCharacterArray1('d','g') will allocate memory for 4 characters - 'd','e','f','g', write all the elements
 * into memory, and return a pointer to it.
 *
 * In case an invalid argument is supplied, the function must throw an instance of std::runtime_error.
 *
 * @param begin a character specifying the minimal element in the inclusive range of characters to be stored in allocated array. It must not exceed the value of end at all times.
 * @param end a character specifying the maximal element in the inclusive range of characters to be stored in allocated array. It must never be less than begin.
 * @return a pointer to dynamically allocated memory.
 */
char* my::createCharacterArray1(char begin, char end) {
    return nullptr;
}

/**
 * Creates a dynamically allocated array of characters and returns a pointer to it.
 *
 * The arguments begin and end specify an inclusive range [begin,end] of values. Hence, begin <= end at all times.
 * In example, createCharacterArray1('d','g') will allocate memory for 4 characters - 'd','e','f','g', write all the elements
 * into memory, and return a pointer to it.
 *
 * In case an invalid argument is supplied, the function must throw an instance of std::runtime_error.
 *
 * @param begin a short integer specifying the minimal element in the inclusive range of characters to be stored in allocated array. It must not exceed the value of end at all times.
 * @param end a short integer specifying the maximal element in the inclusive range of characters to be stored in allocated array. It must never be less than begin.
 * @return a pointer to dynamically allocated memory.
 */
char* my::createCharacterArray2(short begin, short end) {
    return nullptr;
}


/**
 * Creates a dynamically allocated two-dimensional array of integers and fill it with the given data.
 *
 * The arguments begin and end specify an inclusive range [begin,end] of values. Hence, begin <= end at all times.
 * In example, createCharacterArray1('d','g') will allocate memory for 4 characters - 'd','e','f','g', write all the elements
 * into memory, and return a pointer to it.
 *
 * In case invalid argument is supplied, the function must throw an instance of std::runtime_error.
 *
 * A two-dimensional array is an array of pointers, where every element points at the next row.
 *
 * @param rows the number of rows, an integer.
 * @param cols the number of columns, an integer.
 * @param data a pointer to the memory where the data values are stored. rows x cols data items are always available to read.
 * @return the dynamically allocated two-dimensional array, a pointer to a pointer to an integer.
 */
int** my::createMatrix(int rows, int cols, int *data) {
    return nullptr;
}
